# if	!defined	CIE_H
# define	CIE_H

namespace	ColorimetrySpace
{

class	XYZ
	{
	private:
		float	X;
		float	Y;
		float	Z;

	public:
			XYZ(float thisX, float thisY, float thisZ) noexcept;
		float	GetX(void) const noexcept;
		float	GetY(void) const noexcept;
		float	GetZ(void) const noexcept;
		float	GetSum(void) const noexcept;
		void	SetX(float Value) noexcept;
		void	SetY(float Value) noexcept;
		void	SetZ(float Value) noexcept;
	};

class	xyzcc: public XYZ
	{
	private:
		void	Setup(void) noexcept;

	public:
			xyzcc(const XYZ& Argument) noexcept;
	};

class	xyY
	{
	private:
		float	x;
		float	y;
		float	YBig;

	public:
			xyY(float thisx, float thisy, float thisYBig) noexcept;
			xyY(const XYZ& Argument) noexcept;
		float	Getx(void) const noexcept;
		float	Gety(void) const noexcept;
		float	GetYBig(void) const noexcept;
	};

class	Labstar
	{
	private:
		float	Lstar;
		float	astar;
		float	bstar;

	public:
			Labstar(float thisLstar, float thisastar,
				float thisbstar) noexcept;
			Labstar(const XYZ& Argument, const XYZ& Argument_n)
				noexcept;
		float	GetLstar(void) const noexcept;
		float	Getastar(void) const noexcept;
		float	Getbstar(void) const noexcept;
	};

class	LHabCabstar
	{
	private:
		float	Lstar;
		float	Hab;
		float	Cabstar;

	public:
			LHabCabstar(float thisLstar, float thisHab,
				float thisCabstar) noexcept;
			LHabCabstar(const XYZ& Argument, const XYZ& Argument_n)
				noexcept;
			LHabCabstar(const Labstar& Argument) noexcept;
		float	GetLstar(void) const noexcept;
		float	GetHab(void) const noexcept;
		float	GetCabstar(void) const noexcept;
	};

class	uvapostr
	{
	private:
		float	uapostr;
		float	vapostr;

	public:
			uvapostr(float thisuapostr, float thisvapostr) noexcept;
			uvapostr(const XYZ& Argument) noexcept;
		float	Getuapostr(void) const noexcept;
		float	Getvapostr(void) const noexcept;
	};

class	Luvstar
	{
	private:
		float	Lstar;
		float	ustar;
		float	vstar;

	public:
			Luvstar(float thisLstar, float thisustar,
				float thisvstar) noexcept;
			Luvstar(const XYZ& Argument, const XYZ& Argument_n)
				noexcept;
		float	GetLstar(void) const noexcept;
		float	Getustar(void) const noexcept;
		float	Getvstar(void) const noexcept;

	};

class	LHuvCuvstar
	{
	private:
		float	Lstar;
		float	Huv;
		float	Cuvstar;

	public:
			LHuvCuvstar(float thisLstar, float thisHuv,
				float thisCuvstar) noexcept;
			LHuvCuvstar(const XYZ& Argument, const XYZ& Argument_n)
				noexcept;
			LHuvCuvstar(const Luvstar& Argument) noexcept;
		float	GetLstar(void) const noexcept;
		float	GetHuv(void) const noexcept;
		float	GetCuvstar(void) const noexcept;
	};

class	CIEColorSystems
	{
	private:
		XYZ	XYZValue;
		xyzcc	xyzccValue;
		xyY	xyYValue;

	public:
			CIEColorSystems(const XYZ& Argument) noexcept;
		XYZ	GetXYZ(void) const noexcept;
		xyzcc	Getxyzcc(void) const noexcept;
		xyY	GetxyY(void) const noexcept;

	};

class	CIE76ColorSystems
	{
	private:
		Labstar		LabstarValue;
		LHabCabstar	LHabCabstarValue;
		Luvstar		LuvstarValue;
		LHuvCuvstar	LHuvCuvstarValue;
		uvapostr	uvapostrValue;

	public:
				CIE76ColorSystems(const XYZ& Argument,
					const XYZ& Argument_n) noexcept;
		Labstar		GetLabstar(void) const noexcept;
		LHabCabstar	GetLHabCabstar(void) const noexcept;
		Luvstar		GetLuvstar(void) const noexcept;
		LHuvCuvstar	GetLHuvCuvstar(void) const noexcept;
		uvapostr	Getuvapostr(void) const noexcept;
	};

extern	float	Compute_n3(float Value) noexcept;

}

# endif
