# include	<string.h>
# include	"ColorException.h"
# include	"CMF.h"
# include	"CMF_CIE31_1nm.tbl"
# include	"CMF_CIE64_1nm.tbl"

namespace	ColorimetrySpace
{

CMF	CMFCIE31(CMF_CIE31_1nm, sizeof(CMF_CIE31_1nm) / sizeof(CMFData));

CMF	CMFCIE64(CMF_CIE64_1nm, sizeof(CMF_CIE64_1nm) / sizeof(CMFData));

CMF::CMF(register const CMFData Table [], register unsigned int Elements)
	noexcept(false): NumValues(Elements)
	{
	Data = static_cast<CMFData*>(memcpy(new CMFData [Elements],
		Table, Elements * sizeof(CMFData)));
	}

CMF::~CMF(void) noexcept
	{
	delete [] Data;
	}

unsigned int	CMF::GetNumValues(void) const noexcept
	{
	return NumValues;
	}

float	CMF::GetX(unsigned int Index) const noexcept(false)
	{
	if (Index >= NumValues)
		throw ColorExceptionType::InvalidIndex;
	return Data  [Index].Xcmf;
	}

float	CMF::GetY(unsigned int Index) const noexcept(false)
	{
	if (Index >= NumValues)
		throw ColorExceptionType::InvalidIndex;
	return Data  [Index].Ycmf;
	}

float	CMF::GetZ(unsigned int Index) const noexcept(false)
	{
	if (Index >= NumValues)
		throw ColorExceptionType::InvalidIndex;
	return Data  [Index].Zcmf;
	}

}
