# if	!defined	CMF_H
# define	CMF_H

namespace	ColorimetrySpace
{

struct	CMFData
	{
	unsigned int	Wavelength;
	float		Xcmf;
	float		Ycmf;
	float		Zcmf;
	};

class	CMF
	{
	private:
		CMFData*	Data;
		unsigned int	NumValues;

	public:
				CMF(register const CMFData Table [],
					register unsigned int Elements)
					noexcept(false);
				CMF(const CMF& thisCMF) = delete;
				CMF(CMF&& thisCMF) = delete;
		CMF&		operator = (const CMF& thisCMF) = delete;
		CMF&		operator = (CMF&& thisCMF) = delete;
				~CMF(void) noexcept;
		unsigned int	GetNumValues(void) const noexcept;
		float		GetX(unsigned int Index) const noexcept(false);
		float		GetY(unsigned int Index) const noexcept(false);
		float		GetZ(unsigned int Index) const noexcept(false);
	};

extern	CMF	CMFCIE31;

extern	CMF	CMFCIE64;

}

#endif
