# if	!defined	LMS_H
# define	LMS_H

# include	"CIE.h"

namespace	ColorimetrySpace
{

enum	class	ColorRepresentationType { VOS, SS2, SS10 };

class	LMS
	{
	protected:
		float	L;
		float	M;
		float	S;

	public:
			LMS(float thisL, float thisM, float thisS) noexcept;
			LMS(const XYZ& Argument,
				ColorRepresentationType Representation)
				noexcept;
		float	GetL(void) const noexcept;
		float	GetM(void) const noexcept;
		float	GetS(void) const noexcept;
	};

class	lmscc: public LMS
	{
	public:
		lmscc(float thisL, float thisM, float thisS) noexcept;
		lmscc(const LMS& Argument) noexcept;
		lmscc(const XYZ& Argument,
			ColorRepresentationType Representation) noexcept;
	};

class	lsY
	{
	private:
		float	l;
		float	s;
		float	Y;

	public:
			lsY(float thisl, float thiss, float thisY) noexcept;
			lsY(const LMS& Argument) noexcept;
			lsY(const XYZ& Argument,
				ColorRepresentationType Representation)
				noexcept;
		float	Getl(void) const noexcept;
		float	Gets(void) const noexcept;
		float	GetY(void) const noexcept;
	};

class	FundamentalColorSystem
	{
	private:
		LMS	LMSValue;
		lmscc	lmsccValue;
		lsY	lsYValue;

	public:
			FundamentalColorSystem(const LMS& thisLMS) noexcept;
			FundamentalColorSystem(const XYZ& Argument,
				ColorRepresentationType Representation)
				noexcept;
		LMS	GetLMS(void) const noexcept;
		lmscc	Getlmscc(void) const noexcept;
		lsY	GetlsY(void) const noexcept;
	};

}

# endif
