namespace	ColorimetrySpace
{

extern	inline	constexpr	float	DegreesToRadians(float Degrees) noexcept
	{
	return Degrees * (M_PI / 180);
	}

extern	inline	constexpr	float	RadiansToDegrees(float Radians) noexcept
	{
	return Radians * (180 / M_PI);
	}

extern	inline	float	Arctan(float y, float x) noexcept
	{
	float	Result;

	if (y == 0)
		return 0;
	if (x == 0)
		return y > 0? 90: 270;
	Result = RadiansToDegrees(atan(y / x));
	if (x > 0)
		return y > 0? Result: Result + 360;
	return Result + 180;
	}

extern	inline	constexpr	float	Square(float Argument) noexcept
	{
	return Argument * Argument;
	}

extern	inline	constexpr	float	SeventhPower(float Argument) noexcept
	{
	return Argument * Square(Argument * Square(Argument));
	}

}
